# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define appdir  %{_datadir}/%{name}
%define section free
%define _binary_payload w9.gzdio
%define _source_payload w9.gzdio
%define _binary_filedigest_algorithm 1
%define _source_filedigest_algorithm 1

Name:           jext
Version:        3.2
Release:        0.pre4.4%{?dist}
Epoch:          0
Summary:        Free source code editor written in Java
License:        GPL
URL:            http://www.jext.org/
Group:          Text Editors
Source0:        http://osdn.dl.sourceforge.net/jext/jext-sources-3.2pre4.tar.gz
Source1:        %{name}-script
Source2:        %{name}-icon-16.png
Source3:        %{name}-icon-32.png
Source4:        %{name}-icon-48.png
Source5:        %{name}.desktop
Patch0:         %{name}-build.patch
Patch1:         %{name}-Console.patch
Requires:       aelfred
Requires:       gnu-regexp
Requires:       jpackage-utils >= 0:1.7.5
Requires:       java >= 0:1.6.0
Requires:       jython
BuildRequires:  ant >= 0:1.7.1
BuildRequires:  aelfred
BuildRequires:  gnu-regexp
BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  jython
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
Jext was created to support Java programming language. But nowadays it
can edit many other types of source codes. Among them you'll find C,
C++, C#, ASP, PHP, Python, Perl, Ruby, TeX, XHTML, XSLT, Eiffel, JSP...
Besides it provides advanced features to ease you work. Manage your
projects with the bookmarks tool, categorize your opened files through
workspaces, directly open zipped files, get a file straight from the
Internet, mail your source code, executes system commands within the
internal console, type faster thanks to HyperTyper and to the
customizable code snippets library, add new features with plugins,
discover the advanced editing capabilities, use the internal Python
interpreter... Jext meets all your needs! Developers will also
appreciate the open architecture of Jext. Based on GPLed libraries,
internal Python interpreter and many XML files, improving Jext is an
easy job. You can even write your own plugins (in Python or Java).

%package        javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description    javadoc
Javadoc for %{name}.

%prep
%setup -q -n jextSrc-3.2pre4
# remove internal aelfred sources
rm -rf src/lib/com
# remove internal gnu.regexp sources
rm -rf src/lib/gnu
# remove old jedit syntax sources
# FIXME: we don't package a version of jedit this old
#rm -rf src/lib/org/gjt
%patch0 -b .sav0
%patch1 -b .sav1

%build
pushd src
export CLASSPATH=$(build-classpath aelfred gnu.regexp jython)
perl -p -i -e 's|compress="no"|compress="yes"|g' build.xml
perl -p -i -e 's|^Class-Path:||g' %{name}.manifest
ant jar javadocs
popd

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -m 644 lib/%{name}.jar \
$RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
install -m 644 lib/dawn.jar \
$RPM_BUILD_ROOT%{_javadir}/%{name}-dawn-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do \
ln -sf ${jar} ${jar/-%{version}/}; done)

# data
install -p -d -m 755 $RPM_BUILD_ROOT%{appdir}

# scripts
install -D -p -m 755 %{SOURCE1} $RPM_BUILD_ROOT%{_bindir}/%{name}

# javadoc
install -p -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr docs/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
(cd $RPM_BUILD_ROOT%{_javadocdir} && ln -sf %{name}-%{version} %{name})

# freedesktop.org menu entry
install -D -p -m 644 %{SOURCE5} \
  $RPM_BUILD_ROOT%{_datadir}/applications/jpackage-%{name}.desktop

# icons for freedesktop.org and legacy menu entries
install -D -p -m 644 %{SOURCE2} \
  $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/16x16/apps/%{name}.png
install -D -p -m 644 %{SOURCE3} \
  $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/32x32/apps/%{name}.png
install -D -p -m 644 %{SOURCE4} \
  $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/48x48/apps/%{name}.png
install -D -p -m 644 %{SOURCE4} \
  $RPM_BUILD_ROOT%{_datadir}/pixmaps/%{name}.png

%clean
rm -rf $RPM_BUILD_ROOT

%post

%postun

%files
%defattr(0644,root,root,0755)
%doc LICENSE SOURCES
%{_javadir}
%attr(0755,root,root) %{_bindir}/*
%dir %{appdir}
%{_datadir}/applications/*-%{name}.desktop
%{_datadir}/icons/*/*/apps/*
%{_datadir}/pixmaps/%{name}.png

%files javadoc
%defattr(0644,root,root,0755)
%dir %{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}-%{version}/*
%doc %{_javadocdir}/%{name}

%changelog
* Sat Sep 01 2012 Ralph Apel <r.apel at r-apel.de> - 0:3.2-0.pre4.4
- First JPP-6 release

* Tue Feb 27 2007 Ralph Apel <r.apel at r-apel.de> - 0:3.2-0.pre4.3jpp
- First JPP-1.7 release
- Add gcj_support option

* Sun Aug 23 2004 Randy Watler <rwatler at finali.com> - 0:3.2-0.pre4.2jpp
- Rebuild with ant-1.6.2
* Wed Jan 21 2004 David Walluck <david@anti-microsoft.org> 0:3.2-0.pre4.1jpp
- 3.2.0pre4
- compress jar
- remove classpath from manifest

* Fri Oct 10 2003 David Walluck <david@anti-microsoft.org> 0:3.2-0.pre3.1jpp
- release
